/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the IdentitiesAllowedToPost type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &IdentitiesAllowedToPost{}

// IdentitiesAllowedToPost struct for IdentitiesAllowedToPost
type IdentitiesAllowedToPost struct {
	GroupMailSettingsId NullableString `json:"groupMailSettingsId,omitempty"`
	IdentityId          NullableString `json:"identityId,omitempty"`
}

// NewIdentitiesAllowedToPost instantiates a new IdentitiesAllowedToPost object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIdentitiesAllowedToPost() *IdentitiesAllowedToPost {
	this := IdentitiesAllowedToPost{}
	return &this
}

// NewIdentitiesAllowedToPostWithDefaults instantiates a new IdentitiesAllowedToPost object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIdentitiesAllowedToPostWithDefaults() *IdentitiesAllowedToPost {
	this := IdentitiesAllowedToPost{}
	return &this
}

// GetGroupMailSettingsId returns the GroupMailSettingsId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentitiesAllowedToPost) GetGroupMailSettingsId() string {
	if o == nil || IsNil(o.GroupMailSettingsId.Get()) {
		var ret string
		return ret
	}
	return *o.GroupMailSettingsId.Get()
}

// GetGroupMailSettingsIdOk returns a tuple with the GroupMailSettingsId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentitiesAllowedToPost) GetGroupMailSettingsIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.GroupMailSettingsId.Get(), o.GroupMailSettingsId.IsSet()
}

// HasGroupMailSettingsId returns a boolean if a field has been set.
func (o *IdentitiesAllowedToPost) HasGroupMailSettingsId() bool {
	if o != nil && o.GroupMailSettingsId.IsSet() {
		return true
	}

	return false
}

// SetGroupMailSettingsId gets a reference to the given NullableString and assigns it to the GroupMailSettingsId field.
func (o *IdentitiesAllowedToPost) SetGroupMailSettingsId(v string) {
	o.GroupMailSettingsId.Set(&v)
}

// SetGroupMailSettingsIdNil sets the value for GroupMailSettingsId to be an explicit nil
func (o *IdentitiesAllowedToPost) SetGroupMailSettingsIdNil() {
	o.GroupMailSettingsId.Set(nil)
}

// UnsetGroupMailSettingsId ensures that no value is present for GroupMailSettingsId, not even an explicit nil
func (o *IdentitiesAllowedToPost) UnsetGroupMailSettingsId() {
	o.GroupMailSettingsId.Unset()
}

// GetIdentityId returns the IdentityId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentitiesAllowedToPost) GetIdentityId() string {
	if o == nil || IsNil(o.IdentityId.Get()) {
		var ret string
		return ret
	}
	return *o.IdentityId.Get()
}

// GetIdentityIdOk returns a tuple with the IdentityId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentitiesAllowedToPost) GetIdentityIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.IdentityId.Get(), o.IdentityId.IsSet()
}

// HasIdentityId returns a boolean if a field has been set.
func (o *IdentitiesAllowedToPost) HasIdentityId() bool {
	if o != nil && o.IdentityId.IsSet() {
		return true
	}

	return false
}

// SetIdentityId gets a reference to the given NullableString and assigns it to the IdentityId field.
func (o *IdentitiesAllowedToPost) SetIdentityId(v string) {
	o.IdentityId.Set(&v)
}

// SetIdentityIdNil sets the value for IdentityId to be an explicit nil
func (o *IdentitiesAllowedToPost) SetIdentityIdNil() {
	o.IdentityId.Set(nil)
}

// UnsetIdentityId ensures that no value is present for IdentityId, not even an explicit nil
func (o *IdentitiesAllowedToPost) UnsetIdentityId() {
	o.IdentityId.Unset()
}

func (o IdentitiesAllowedToPost) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o IdentitiesAllowedToPost) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.GroupMailSettingsId.IsSet() {
		toSerialize["groupMailSettingsId"] = o.GroupMailSettingsId.Get()
	}
	if o.IdentityId.IsSet() {
		toSerialize["identityId"] = o.IdentityId.Get()
	}
	return toSerialize, nil
}

type NullableIdentitiesAllowedToPost struct {
	value *IdentitiesAllowedToPost
	isSet bool
}

func (v NullableIdentitiesAllowedToPost) Get() *IdentitiesAllowedToPost {
	return v.value
}

func (v *NullableIdentitiesAllowedToPost) Set(val *IdentitiesAllowedToPost) {
	v.value = val
	v.isSet = true
}

func (v NullableIdentitiesAllowedToPost) IsSet() bool {
	return v.isSet
}

func (v *NullableIdentitiesAllowedToPost) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIdentitiesAllowedToPost(val *IdentitiesAllowedToPost) *NullableIdentitiesAllowedToPost {
	return &NullableIdentitiesAllowedToPost{value: val, isSet: true}
}

func (v NullableIdentitiesAllowedToPost) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIdentitiesAllowedToPost) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
